#!/usr/bin/perl -w
use File::Basename;

foreach $in (@ARGV) {
	open(P, "+<$in") || die "can't open $in \n";
	binmode(P);

	# - PS data address check
	seek (P,0,0); #TIFF preview
	if (( ord (getc P) + ord (getc P) * 0x100 ) == 53445 ) {
		seek (P,4,0); #PS start
		$psstrt = ord (getc P) + ord (getc P) * 0x100 + ord (getc P) * 0x10000 + ord (getc P) * 0x1000000;
		seek (P,8,0); #PS size
		$psend = $psstrt + ord (getc P) + ord (getc P) * 0x100 + ord (getc P) * 0x10000 + ord (getc P) * 0x1000000;
	}else{
		$psstrt = 0;
		seek (P,0,2);
		$psend = tell (P);
	}

	# - return code check
	$os = 0;
	seek (P,$psstrt+23,0);
	$c = getc P;
	if ($c eq chr (hex('0x0A'))) {
		$/ = pack ("C", hex("A"));
		$os = 1; # unix LF
	} elsif ($c eq chr (hex('0x0D'))) {
		$/ = pack("C", hex("D"));
		$os = 2; # mac CR
		if (getc P eq chr (hex('0x0A'))) {
			$/ = pack("C", hex("A"));
			$os = 3; # win CR+LF
		}
	}

	if ($os != 0) {
		# - main
		seek (P,$psstrt,0);
		$lin = 0;
		$acro = 0;
		$find = 0;
		while (<P>) {
			if (($lin++ == 0) && (/^%\!PS-Adobe-/ eq '')) {
				last;
			}
			if (/^%%\+ procset \(Adobe Acrobat \- PDF operators\)/) {
				$acro = 1;
			}
			if ($acro == 1) {
				if (/^%%EndSetup/) {
					$find = 1;
				}
				if ($find  == 1 && (/^\/pdfmark where \{pop \[ \{ThisPage\} 1 dict begin/)) {
					seek (P,-length($_),1);
					for ($i = 1; $i < length($_); $i++) {
						print P " ";
					}
				}
				if (/^PDFVars begin PDF begin PDFVars\/InitAll get exec/) {
					last;
				}
			}else{
				if (/^%%EndSetup/) {
					last;
				}
				if (/^%%Page:/) {
					last;
				}
			}
			if(/^%%Begin(?:Data|Binary):\s+(\d+)/) {
				seek (P, $1, 1);
			}
			if (tell (P) >= $psend) {
				last;
			}
		}
	}
	close (P);
}
